diff --git a/pyrpkg/__init__.py b/pyrpkg/__init__.py
index c05b753..1448dbb 100644
--- a/pyrpkg/__init__.py
+++ b/pyrpkg/__init__.py
@@ -2192,7 +1845,7 @@ class Commands(object):
 
         # Generate the config
         config = koji.genMockConfig('%s-%s' % (target, arch), arch,
-                                    distribution=self.disttag,
+                                    distribution=self.package.disttag,
                                     tag_name=build_target['build_tag_name'],
                                     repoid=repoid,
                                     topurl=self.topurl)
@@ -2236,7 +1889,7 @@ class Commands(object):
         Returns used config directory
         """
         if not root:
-            root = self.mockconfig
+            root = self.package.mockconfig
         if not config_dir:
             my_config_dir = tempfile.mkdtemp(prefix="%s." % root,
                                              suffix='mockconfig')
@@ -2295,7 +1948,7 @@ class Commands(object):
 
         config_dir = None
         if not root:
-            root = self.mockconfig
+            root = self.package.mockconfig
             chroot_cfg = '/etc/mock/%s.cfg' % root
             if not os.path.exists(chroot_cfg):
                 self.log.debug('Mock config %s was not found. Going to'
@@ -2335,7 +1988,8 @@ class Commands(object):
         :raises rpkgError: if failed to add a file to file `sources`.
         """
 
-        sourcesf = SourcesFile(self.sources_filename, self.source_entry_type,
+        sourcesf = SourcesFile(self.package.sources_filename,
+                               self.source_entry_type,
                                replace=replace)
         gitignore = GitIgnore(os.path.join(self.path, '.gitignore'))
 
@@ -2356,15 +2010,19 @@ class Commands(object):
                     '    `%(arg0)s new-sources file1 file2 ...`']) % {
                         'newhash': e.new_hashtype,
                         'existinghash': e.existing_hashtype,
-                        'sources': self.sources_filename,
+                        'sources': self.package.sources_filename,
                         'arg0': sys.argv[0],
                     }
                 raise rpkgError(msg)
 
             gitignore.add('/%s' % file_basename)
-            self.lookasidecache.upload(
-                self.ns_repo_name if self.lookaside_namespaced else self.repo_name,
-                f, file_hash)
+
+            if self.lookaside_namespaced:
+                repo_name = self.package.ns_repo_name
+            else:
+                repo_name = self.package.repo_name
+
+            self.lookasidecache.upload(repo_name, f, file_hash)
 
         sourcesf.write()
         gitignore.write()
@@ -2381,7 +2039,7 @@ class Commands(object):
 
         # setup the rpm command
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines)
+        cmd.extend(self.package.rpmdefines)
         if builddir:
             # Tack on a new builddir to the end of the defines
             cmd.append("--define '_builddir %s'" % os.path.abspath(builddir))
@@ -2389,7 +2047,7 @@ class Commands(object):
             cmd.extend(['--target', arch])
         if self.quiet:
             cmd.append('--quiet')
-        cmd.extend(['--nodeps', '-bp', os.path.join(self.path, self.spec)])
+        cmd.extend(['--nodeps', '-bp', os.path.join(self.path, self.package.spec)])
         # Run the command
         self._run_command(cmd, shell=True)
 
@@ -2403,16 +2061,14 @@ class Commands(object):
             digests.
         """
 
-        self.srpmname = os.path.join(self.path,
-                                     "%s-%s-%s.src.rpm"
-                                     % (self.repo_name, self.ver, self.rel))
+        self.srpmname = os.path.join(self.path, self.package.srpm_filename)
 
         # See if we need to build the srpm
         if os.path.exists(self.srpmname):
             self.log.debug('Srpm found, rewriting it.')
 
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines)
+        cmd.extend(self.package.rpmdefines)
         if self.quiet:
             cmd.append('--quiet')
         # Figure out which hashtype to use, if not provided one
@@ -2425,7 +2081,7 @@ class Commands(object):
                         % hashtype,
                         "--define '_binary_filedigest_algorithm %s'"
                         % hashtype])
-        cmd.extend(['--nodeps', '-bs', os.path.join(self.path, self.spec)])
+        cmd.extend(['--nodeps', '-bs', os.path.join(self.path, self.package.spec)])
         self._run_command(cmd, shell=True)
 
     def unused_patches(self):
@@ -2438,7 +2094,7 @@ class Commands(object):
         # Create a list for unused patches
         unused = []
         # Get the content of spec into memory for fast searching
-        with open(os.path.join(self.path, self.spec), 'r') as f:
+        with open(os.path.join(self.path, self.package.spec), 'r') as f:
             data = f.read()
         if six.PY2:
             try:
@@ -2452,9 +2108,9 @@ class Commands(object):
         else:
             spec = data
         # Replace %{name} with the package name
-        spec = spec.replace("%{name}", self.repo_name)
+        spec = spec.replace("%{name}", self.package.repo_name)
         # Replace %{version} with the package version
-        spec = spec.replace("%{version}", self.ver)
+        spec = spec.replace("%{version}", self.package.ver)
 
         # Get a list of files tracked in source control
         files = self.repo.git.ls_files('--exclude-standard').split()
@@ -2492,13 +2148,13 @@ class Commands(object):
 
         # setup the rpm command
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines)
+        cmd.extend(self.package.rpmdefines)
         if builddir:
             # Tack on a new builddir to the end of the defines
             cmd.append("--define '_builddir %s'" % os.path.abspath(builddir))
         if self.quiet:
             cmd.append('--quiet')
-        cmd.extend(['-bl', os.path.join(self.path, self.spec)])
+        cmd.extend(['-bl', os.path.join(self.path, self.package.spec)])
         # Run the command
         self._run_command(cmd, shell=True)
 
@@ -2508,8 +2164,11 @@ class Commands(object):
                              koji_task_watcher=None,
                              nowait=False):
         # check if repo is dirty and all commits are pushed
-        self.repo.check()
-        container_target = self.target if target_override else self.container_build_target
+        self.check_repo()
+        if target_override:
+            container_target = self.package.target
+        else:
+            container_target = self.package.container_build_target
 
         # This is for backward-compatibility of deprecated kojiconfig.
         # Signature of container_build_koji is not changed in case someone
@@ -2755,7 +2414,7 @@ class Commands(object):
         if not scm_url and check_repo:
             # Make sure the local repo is clean (no unpushed changes) if the
             # user didn't specify an SCM URL
-            self.repo.check()
+            self.check_repo()
 
         if branch:
             actual_branch = branch
@@ -2775,7 +2434,7 @@ class Commands(object):
             # If the scm_url isn't specified, get the remote git URL of the
             # git repo the current user is in
             actual_scm_url = self._get_namespace_anongiturl(
-                self.ns_repo_name)
+                self.package.ns_repo_name)
             actual_scm_url = '{0}?#{1}'.format(actual_scm_url, self.repo.commit_hash)
         return actual_scm_url, actual_branch
 
diff --git a/pyrpkg/cli.py b/pyrpkg/cli.py
index adda37a..bb6d4eb 100644
--- a/pyrpkg/cli.py
+++ b/pyrpkg/cli.py
@@ -277,21 +277,23 @@ class cliClient(object):
                                        )
 
         if self.args.module_name:
+            this_pkg = self._cmd.package
             # Repository name was specified via argument
             if '/' not in self.args.module_name:
-                self._cmd.repo_name = self.args.module_name
+                this_pkg.repo_name = self.args.module_name
                 if dg_namespaced:
                     # No slash, assume rpms namespace
-                    self._cmd.ns = 'rpms'
+                    this_pkg.ns = 'rpms'
             else:
-                self._cmd.ns, self._cmd.repo_name = self.args.module_name.rsplit('/', 1)
+                this_pkg.ns, this_pkg.module_name = self.args.module_name.rsplit('/', 1)
 
         if self.args.repo_name:
-            self._cmd.repo_name = self.args.repo_name
+            this_pkg = self._cmd.package
+            this_pkg.repo_name = self.args.repo_name
             if dg_namespaced and self.args.repo_namespace:
-                self._cmd.ns = self.args.repo_namespace
+                this_pkg.ns = self.args.repo_namespace
             else:
-                self._cmd.ns = 'rpms'
+                this_pkg.ns = 'rpms'
 
         self._cmd.password = self.args.password
         self._cmd.runas = self.args.runas
@@ -1439,7 +1441,7 @@ see API KEY section of copr-cli(1) man page.
             if self.args.srpm == 'CONSTRUCT':
                 self.log.debug('Generating an srpm')
                 self.srpm()
-                self.args.srpm = '%s.src.rpm' % self.cmd.nvr
+                self.args.srpm = '%s.src.rpm' % self.cmd.package.nvr
             # Figure out if we want a verbose output or not
             callback = None
             if not self.args.q:
@@ -1480,8 +1482,8 @@ see API KEY section of copr-cli(1) man page.
         return koji_cli.lib.watch_tasks(self.cmd.kojisession, [task_id])
 
     def chainbuild(self):
-        if self.cmd.module_name in self.args.package:
-            raise Exception('%s must not be in the chain' % self.cmd.module_name)
+        if self.cmd.package.module_name in self.args.package:
+            raise Exception('%s must not be in the chain' % self.cmd.package.module_name)
 
         # make sure we didn't get an empty chain
         if self.args.package == [':']:
@@ -1581,7 +1583,7 @@ see API KEY section of copr-cli(1) man page.
         try:
             self.cmd.commit(self.args.message, self.args.file, self.args.files, self.args.signoff)
             if self.args.tag:
-                tagname = self.cmd.nvr
+                tagname = self.cmd.package.nvr
                 self.cmd.add_tag(tagname, True, self.args.message, self.args.file)
         except Exception:
             if self.args.tag:
@@ -1677,7 +1679,7 @@ see API KEY section of copr-cli(1) man page.
         self.log.debug('Generating an srpm')
         self.args.hash = None
         self.srpm()
-        srpm_name = '%s.src.rpm' % self.cmd.nvr
+        srpm_name = '%s.src.rpm' % self.cmd.package.nvr
         self.cmd.copr_build(self.args.project[0],
                             srpm_name,
                             self.args.nowait,
@@ -1687,7 +1689,7 @@ see API KEY section of copr-cli(1) man page.
         self.cmd.diff(self.args.cached, self.args.files)
 
     def gimmespec(self):
-        print(self.cmd.spec)
+        print(self.cmd.package.spec)
 
     def gitbuildhash(self):
         print(self.cmd.gitbuildhash(self.args.build))
@@ -1822,7 +1824,7 @@ see API KEY section of copr-cli(1) man page.
             stream = self.args.stream
 
         if not self.args.file_path:
-            file_path = os.path.join(self.cmd.path, self.cmd.module_name + ".yaml")
+            file_path = os.path.join(self.cmd.path, self.cmd.package.module_name + ".yaml")
         else:
             file_path = self.args.file_path
 
@@ -2074,7 +2076,7 @@ see API KEY section of copr-cli(1) man page.
             tagname = self.args.tag
             if not tagname or self.args.clog:
                 if not tagname:
-                    tagname = self.cmd.nvr
+                    tagname = self.cmd.package.nvr
                 if self.args.clog:
                     self.cmd.clog(self.args.raw)
                     filename = 'clog'
@@ -2089,8 +2091,8 @@ see API KEY section of copr-cli(1) man page.
         self.cmd.verify_files(builddir=self.args.builddir)
 
     def verrel(self):
-        print('%s-%s-%s' % (self.cmd.module_name, self.cmd.ver,
-                            self.cmd.rel))
+        this_pkg = self.cmd.package
+        print('%s-%s-%s' % (this_pkg.module_name, this_pkg.ver, this_pkg.rel))
 
     # Stole these three functions from /usr/bin/koji
     def setupLogging(self, log):
diff --git a/pyrpkg/pkginfo.py b/pyrpkg/pkginfo.py
new file mode 100644
index 0000000..c9bdcc5
--- /dev/null
+++ b/pyrpkg/pkginfo.py
@@ -0,0 +1,394 @@
+# pyrpkg - a Python library for RPM Packagers
+#
+# Copyright (C) 2018 Red Hat Inc.
+# Author(s): Chenxiong Qi <cqi@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 2 of the License, or (at your
+# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
+# the full text of the license.
+
+import logging
+import os
+import re
+import subprocess
+import posixpath
+
+from six.moves import urllib
+from pyrpkg.errors import rpkgError
+
+logger = logging.getLogger(__name__)
+
+
+class PackageMetadata(object):
+    """Package metadata"""
+
+    def __init__(self, repo, overwrite_target=None, distgit_namespaced=True):
+        """Initialization
+
+        :param repo: object of ``PackageRepo`` representing underlying package
+            repository.
+        :type repo: :class:`PackageRepository <pyrpkg.pkgrepo.PackageRepository>`
+        :param bool distgit_namespaced: whether namespace is enabled in
+            dist-git.
+        """
+        self.repo = repo
+        self.distgit_namespaced = distgit_namespaced
+
+        self._disttag = None
+        self._distval = None
+        self._distvar = None
+        self._epoch = None
+        self._localarch = None
+        self._mockconfig = None
+        self._module_name = None
+        self._nvr = None
+        self._spec = None
+        self._rpmdefines = None
+        self._ver = None
+        self._ns = None
+
+        # The build target for containers within the buildsystem
+        self._container_build_target = overwrite_target
+        self._target = overwrite_target
+
+        # Deprecates self.module_name
+        self._repo_name = None
+
+    @property
+    def disttag(self):
+        """This property ensures the disttag attribute"""
+
+        if not self._disttag:
+            self.load_rpmdefines()
+        return self._disttag
+
+    @property
+    def distval(self):
+        """This property ensures the distval attribute"""
+
+        if not self._distval:
+            self.load_rpmdefines()
+        return self._distval
+
+    @property
+    def distvar(self):
+        """This property ensures the distvar attribute"""
+
+        if not self._distvar:
+            self.load_rpmdefines()
+        return self._distvar
+
+    @property
+    def epoch(self):
+        """This property ensures the epoch attribute"""
+
+        if not self._epoch:
+            self.load_nameverrel()
+        return self._epoch
+
+    @property
+    def localarch(self):
+        """This property ensures the module attribute"""
+
+        if not self._localarch:
+            self.load_localarch()
+        return(self._localarch)
+
+    def load_localarch(self):
+        """Get the local arch as defined by rpm"""
+
+        proc = subprocess.Popen(['rpm --eval %{_arch}'], shell=True,
+                                stdout=subprocess.PIPE,
+                                universal_newlines=True)
+        self._localarch = proc.communicate()[0].strip('\n')
+
+    @property
+    def mockconfig(self):
+        """This property ensures the mockconfig attribute"""
+
+        if not self._mockconfig:
+            self.load_mockconfig()
+        return self._mockconfig
+
+    @mockconfig.setter
+    def mockconfig(self, config):
+        self._mockconfig = config
+
+    def load_mockconfig(self):
+        """This sets the mockconfig attribute"""
+
+        self._mockconfig = '%s-%s' % (self.target, self.localarch)
+
+    @property
+    def ns(self):
+        """This property provides the namespace of the module"""
+
+        if not self._ns:
+            self.load_ns()
+        return self._ns
+
+    @ns.setter
+    def ns(self, ns):
+        self._ns = ns
+
+    def load_ns(self):
+        """Loads the namespace"""
+
+        try:
+            if self.distgit_namespaced:
+                if self.repo.push_url:
+                    parts = urllib.parse.urlparse(self.repo.push_url)
+
+                    path_parts = [p for p in parts.path.split("/") if p]
+                    if len(path_parts) == 1:
+                        path_parts.insert(0, "rpms")
+                    ns = path_parts[-2]
+
+                    self._ns = ns
+            else:
+                self._ns = None
+                logger.info("Could not find ns, distgit is not namespaced")
+        except rpkgError:
+            logger.warning('Failed to get ns from Git url or pushurl')
+
+    @property
+    def ns_module_name(self):
+        logger.warning('Property ns_module_name is deprecated. Please use '
+                         'ns_repo_name instead.')
+        return self.ns_repo_name
+
+    @property
+    def ns_repo_name(self):
+        if self.distgit_namespaced:
+            return '%s/%s' % (self.ns, self.repo_name)
+        else:
+            return self.repo_name
+
+    @property
+    def nvr(self):
+        """This property ensures the nvr attribute"""
+
+        if not self._nvr:
+            self.load_nvr()
+        return self._nvr
+
+    def load_nvr(self):
+        """This sets the nvr attribute"""
+        self._nvr = '{0}-{1}-{2}'.format(self.repo_name, self.ver, self.rel)
+
+    @property
+    def rel(self):
+        """This property ensures the rel attribute"""
+        if not self._rel:
+            self.load_nameverrel()
+        return(self._rel)
+
+    def load_nameverrel(self):
+        """Set the release of a package module."""
+
+        cmd = ['rpm']
+        cmd.extend(self.rpmdefines)
+        # We make sure there is a space at the end of our query so that
+        # we can split it later.  When there are subpackages, we get a
+        # listing for each subpackage.  We only care about the first.
+        cmd.extend(['-q', '--qf', '"%{NAME} %{EPOCH} %{VERSION} %{RELEASE}??"',
+                    '--specfile', '"%s"' % os.path.join(self.repo.path, self.spec)])
+        joined_cmd = ' '.join(cmd)
+        try:
+            proc = subprocess.Popen(joined_cmd, shell=True,
+                                    universal_newlines=True,
+                                    stdout=subprocess.PIPE,
+                                    stderr=subprocess.PIPE)
+            output, err = proc.communicate()
+        except Exception as e:
+            if err:
+                logger.debug('Errors occoured while running following command to get N-V-R-E:')
+                logger.debug(joined_cmd)
+                logger.error(err)
+            raise rpkgError('Could not query n-v-r of %s: %s'
+                            % (self.module_name, e))
+        if err:
+            logger.debug('Errors occoured while running following command to get N-V-R-E:')
+            logger.debug(joined_cmd)
+            logger.error(err)
+        # Get just the output, then split it by ??, grab the first and split
+        # again to get ver and rel
+        first_line_output = output.split('??')[0]
+        parts = first_line_output.split()
+        if len(parts) != 4:
+            raise rpkgError('Could not get n-v-r-e from %r'
+                            % first_line_output)
+        (self._package_name_spec,
+         self._epoch,
+         self._ver,
+         self._rel) = parts
+
+        # Most packages don't include a "Epoch: 0" line, in which case RPM
+        # returns '(none)'
+        if self._epoch == "(none)":
+            self._epoch = "0"
+
+    @property
+    def rpmdefines(self):
+        """This property ensures the rpm defines"""
+
+        if not self._rpmdefines:
+            self.load_rpmdefines()
+        return(self._rpmdefines)
+
+    def load_rpmdefines(self):
+        """Populate rpmdefines based on current active branch"""
+
+        # This is another function ripe for subclassing
+
+        try:
+            # This regex should find the 'rhel-5' or 'rhel-6.2' parts of the
+            # branch name.  There should only be one of those, and all branches
+            # should end in one.
+            osver = re.search(r'rhel-\d.*$', self.repo.branch_merge).group()
+        except AttributeError:
+            raise rpkgError('Could not find the base OS ver from branch name'
+                            ' %s. Consider using --release option' %
+                            self.repo.branch_merge)
+        self._distvar, self._distval = osver.split('-')
+        self._distval = self._distval.replace('.', '_')
+        self._disttag = 'el%s' % self._distval
+        self._rpmdefines = [
+            "--define '_sourcedir %s'" % self.repo.path,
+            "--define '_specdir %s'" % self.repo.path,
+            "--define '_builddir %s'" % self.repo.path,
+            "--define '_srcrpmdir %s'" % self.repo.path,
+            "--define '_rpmdir %s'" % self.repo.path,
+            "--define 'dist .%s'" % self._disttag,
+            "--define '%s %s'" % (self._distvar, self._distval.split('_')[0]),
+            # int and float this to remove the decimal
+            "--define '%s 1'" % self._disttag
+        ]
+
+    @property
+    def spec(self):
+        """This property ensures the module attribute"""
+
+        if not self._spec:
+            self.load_spec()
+        return self._spec
+
+    def load_spec(self):
+        """This sets the spec attribute"""
+
+        deadpackage = False
+
+        # Get a list of files in the path we're looking at
+        files = os.listdir(self.repo.path)
+        # Search the files for the first one that ends with ".spec"
+        for f in files:
+            if f.endswith('.spec') and not f.startswith('.'):
+                self._spec = f
+                return
+            if f == 'dead.package':
+                deadpackage = True
+        if deadpackage:
+            raise rpkgError('No spec file found. This package is retired')
+        else:
+            raise rpkgError('No spec file found.')
+
+    @property
+    def target(self):
+        """This property ensures the target attribute"""
+
+        if not self._target:
+            self.load_target()
+        return self._target
+
+    def load_target(self):
+        """This creates the target attribute based on branch merge"""
+
+        # If a site has a different naming scheme, this would be where
+        # a site would override
+        self._target = '{0}-candidate'.format(self.repo.branch_merge)
+
+    @property
+    def container_build_target(self):
+        """This property ensures the target for container builds."""
+        if not self._container_build_target:
+            self.load_container_build_target()
+        return self._container_build_target
+
+    def load_container_build_target(self):
+        """This creates a target based on git branch and namespace."""
+        self._container_build_target = '{0}-{1}-candidate'.format(
+            self.repo.branch_merge, self.ns)
+
+    @property
+    def ver(self):
+        """This property ensures the ver attribute"""
+        if not self._ver:
+            self.load_nameverrel()
+        return(self._ver)
+
+    @property
+    def sources_filename(self):
+        """File name of sources"""
+        return os.path.join(self.repo.path, 'sources')
+
+    @property
+    def srpm_filename(self):
+        return '{0}-{1}-{2}.src.rpm'.format(self.module_name, self.ver, self.rel)
+
+    @property
+    def repo_name(self):
+        """Property to get repository name"""
+        if not self._repo_name:
+            self.load_repo_name()
+        return self._repo_name
+
+    @repo_name.setter
+    def repo_name(self, name):
+        """Set repository name"""
+        self._repo_name = name
+
+    @property
+    def module_name(self):
+        """This property ensures the module attribute"""
+        logger.warning('Property module_name is deprecated. Please use '
+                         'repo_name instead.')
+        return self.repo_name
+
+    @module_name.setter
+    def module_name(self, module_name):
+        logger.warning('Property module_name is deprecated. Please use '
+                         'repo_name instead.')
+        self.repo_name = module_name
+
+    def load_module_name(self):
+        return self.load_repo_name()
+
+    def load_repo_name(self):
+        """Loads repository name"""
+
+        try:
+            if self.repo.push_url:
+                parts = urllib.parse.urlparse(self.repo.push_url)
+
+                # FIXME
+                # if self.distgit_namespaced:
+                #     self._module_name = "/".join(parts.path.split("/")[-2:])
+                repo_name = posixpath.basename(parts.path.strip('/'))
+
+                if repo_name.endswith('.git'):
+                    repo_name = repo_name[:-len('.git')]
+                self._repo_name = repo_name
+                return
+        except rpkgError:
+            logger.warning('Failed to get repository name from Git url or pushurl')
+
+        self.load_nameverrel()
+        if self._package_name_spec:
+            self._repo_name = self._package_name_spec
+            return
+
+        raise rpkgError('Could not find current repository name.'
+                        ' Use --name and optional --namespace.')
+
diff --git a/tests/commands/test_package_name.py b/tests/commands/test_package_name.py
index 6c61856..e6b26ac 100644
--- a/tests/commands/test_package_name.py
+++ b/tests/commands/test_package_name.py
@@ -20,5 +20,5 @@ class CommandPackageNameTestCase(CommandTestCase):
         moduledir = os.path.join(self.path, self.module)
         cmd.path = moduledir
 
-        self.assertNotEqual(type(cmd.module_name), six.binary_type)
-        self.assertEqual(type(cmd.module_name), six.text_type)
+        self.assertNotEqual(type(cmd.package.repo_name), six.binary_type)
+        self.assertEqual(type(cmd.package.repo_name), six.text_type)
diff --git a/tests/commands/test_push.py b/tests/commands/test_push.py
index ee70664..b54e428 100644
--- a/tests/commands/test_push.py
+++ b/tests/commands/test_push.py
@@ -104,7 +104,7 @@ Patch3: d.path
 
         # Track c.patch in sources
         from pyrpkg.sources import SourcesFile
-        sources_file = SourcesFile(self.cmd.sources_filename,
+        sources_file = SourcesFile(self.cmd.package.sources_filename,
                                    self.cmd.source_entry_type)
         file_hash = self.cmd.lookasidecache.hash_file('c.patch')
         sources_file.add_entry(self.cmd.lookasidehash, 'c.patch', file_hash)
